\section{Agents}
\label{sec:agent}
Our system is composed of just one agent which comprises two effectors (a
manipulator with a gripper attached), an exteroceptor (an standalone Kinect
sensor) and it communicates with an external agent whose definition is not
available but that is able to monitor the state of the palette. An sketch of
the system performing the task described in \autoref{itm:task-goal} can be
found in \autoref{fig:sketch}. It illustrates some of the system configuration
transformations that are further defined in \autoref{table:memory}.

\autoref{fig:agents} illustrates the different agent components and how are
they related. It is worth to mention that the real effectors and receptors of
the bottom of diagram matches with the hardware proposed in
\autoref{itm:task-hardware}.

\begin{figure}
    \centering
    \includegraphics[width=0.8\textwidth]{content/agents/sketch.jpg}
    \caption{Sketch of the system agents}
    \label{fig:sketch}
\end{figure}

\begin{figure}
    \centering
    \input{content/agents/agents.tikz}
    \caption{Internal structure of the agents}
    \label{fig:agents}
\end{figure}

\subsection{Sampling rates}
This section explains the different sampling rates of the agent's subsystems,
which is the iteration period of a behaviour of each subsystem. A summary of
the results can be found in \autoref{table:sampling-rates}.

\paragraph{Virtual receptor - aggregates readings from the real receptor}
The \href{https://www.faps.fau.eu/ausbio/microsoft-kinect-v2-3d-camera/}{Kinect
v2 3D-Camera} has a framerate of 30Hz specified by manufacturer. Therefore the
virtual receptor that performs the object recognition and pose estimation will
have an iteration period of $33ms$ approximately.

\paragraph{Virtual effectors}
As it is explained in \autoref{sec:effectors-and-receptors}, the effectors are
defined to be equivalent to the lecture examples. Therefore, both real
effectors, two-state gripper and the 6dof manipulator have a sampling rate of
$500Hz$, which correspond to an iteration period of $2ms$. The virtual
effectors are therefore assumed to have the same sampling rate and iteration
period, consuming the real effector's output buffer and processing it in time
before the next value is issued.

\paragraph{Control subsystem}
Usual values for sampling rates in robotic control systems range between
$500Hz$ and $2000Hz$. This work will assume a frequency of $1000Hz$ which
corresponds to an iteration period of $1ms$.

\begin{table}
\centering
\begin{tabular}{crcl}
\hline
\multirow{2}{*}{Kinect sensor virtual receptor} & 
    $\leftidx{^{r,k}}{\text{f}}{_s}$ & $=$ & $30Hz$\\
& $\leftidx{^{r,k}}{\text{T}}$ & $=$ & $33ms$\\
\hline
\multirow{2}{*}{6dof manipulator virtual effector} & 
    $\leftidx{^{e,m}}{\text{f}}{_s}$ & $=$ & $500Hz$\\
& $\leftidx{^{e,m}}{\text{T}}$ & $=$ & $2ms$\\
\hline
\multirow{2}{*}{Two-state gripper virtual effector} & 
    $\leftidx{^{e,g}}{\text{f}}{_s}$ & $=$ & $500Hz$\\
& $\leftidx{^{e,g}}{\text{T}}$ & $=$ & $2ms$\\
\hline
\multirow{2}{*}{Control subsystem} & 
    $\leftidx{^{c}}{\text{f}}{_s}$ & $=$ & $1000Hz$\\
& $\leftidx{^{c}}{\text{T}}$ & $=$ & $1ms$\\
\hline
\end{tabular}
\caption{Agent's subsystems sampling rates and iteration periods}
\label{table:sampling-rates}
\end{table}